#include "res.h"
#include <vector>



card * pole[6][6][4]; //Игровое поле
//[x][x][0]: это тип занимаемой карты
//Type 100-Border
//Type 99 - Blocked 1
//Type 98 - Blocked 2
//Type 0 - Clear
//Type 1(BlueTp)-Blue
//Type 2(RedTp)-Red
//
//[x][x][1]:ссылка на карту
//[x][x][2]:чья изначально 1B и 2R
//[x][x][3]:номер в стопке

uint8_t Sel_Slot=0;
bool Pl_Half_End=false;////   ; Половина хода игрока
bool Pl_Turn_End=false;////   ;2-я Половина хода

uint8_t Turn=0; //Колличество ходов, при достижении 10 или более, выходим.

uint8_t WhoGo=0; //;Чей ход? 0-синий, 1 красный

uint8_t PPdx=1,PPdy=1;

card * MyCards[5][2]; // Массивы под карты не выложенные
card * EnemyCards[5][2]; //
//св-во 0 :   0-неиспользована 1-использована
//св-во 1 -адрес

bool Game_Local_May_Exit=false;

uint8_t  InGameRed=0;
uint8_t InGameBlue=0;

uint8_t KtoFight[9][2];
uint8_t KtoOkup[9][2];
uint8_t SkFight,SkOkup;

uint8_t NotDraw[2][2]; //две карты, которые не будем рисовать


void ClearPole() // Чистим Поле и ставим границы
{
    memset(pole,0,sizeof(card *)*6*6*4);
    for (uint8_t i=0;i<6;i++)
    {
        pole[i][0][0]=(card *)100;
        pole[i][5][0]=(card *)100;
        pole[0][i][0]=(card *)100;
        pole[5][i][0]=(card *)100;
    }
}

void FlushCards()
{
    memset(MyCards,0,sizeof(card *)*5*2);
    memset(EnemyCards,0,sizeof(card *)*5*2);


    for (uint8_t i=0;i<5;i++)
    {
        card *pss;
        pss=new card;
        pss->Number=rand()%100;
        pss->Attack=rand()%16;
        pss->Atype=(aType)rand()%4;
        pss->Expirience=0;
        pss->MDefence=rand()%16;
        pss->PDefence=rand()%16;
        pss->Arr=(rand() & 0xFF);
        MyCards[i][1]=pss;

        pss=new card;
        pss->Number=rand()%100;
        pss->Attack=rand()%16;
        pss->Atype=rand()%4;
        pss->Expirience=0;
        pss->MDefence=rand()%16;
        pss->PDefence=rand()%16;
        pss->Arr=(rand() & 0xFF);
        EnemyCards[i][1]=pss;

    }


    /* pole[1][1][0]=(card *)98;
     pole[2][1][0]=(card *)99;*/

    /*  pole[3][2][0]=(card *)1;
      pole[3][2][1]=MyCards[2][1];
      MyCards[2][0]=(card *)1;

      pole[2][3][0]=(card *)2;
      pole[2][3][1]=EnemyCards[1][1];
      EnemyCards[1][0]=(card *)1;*/

}

void DrawPlayerCards(SDL_Surface *scr)// Рисуем карты игрока(справа)
{
    for (uint8_t i=0;i<5;i++)
    {
        if (MyCards[i][0]==NULL)
        {
            if (MyCards[i][1])
                DrawCard(MyCards[i][1]->Number,0,264,-1+i*48,MyCards[i][1]->Attack,MyCards[i][1]->Atype,MyCards[i][1]->PDefence,MyCards[i][1]->MDefence,MyCards[i][1]->Arr,scr);
        }
    }
}


void DrawPlayercardsGrayed(uint8_t Crome,SDL_Surface *scr) //Рисуем карты игрока(справа), затемненные кроме выбранной карты.
{
    for (uint8_t i=0;i<5;i++)
    {
        if (MyCards[i][0]==NULL)
            if (i!=Crome)   DrawAImage(blk_crd_img,264,-1+i*48,160,scr);
    }
}


uint32_t LXtoSX(uint8_t x) //Из координат сетки в координаты экрана X
{
    return 71+(x-1)*(43);
}

uint32_t LYtoSY(uint8_t y) //Из координат сетки в координаты экрана Y
{
    return 8+(y-1)*(52);
}


void DrawEnemyCards(SDL_Surface *scr)//Рисуем вражеские карты, задник.
{
    for (uint8_t i=0;i<5;i++)
    {
        if (EnemyCards[i][0]==0)
            if (EnemyCards[i][1])
                DrawImage(enm_Card,16,26+i*14,scr);
    }
}

void Global_Draw_Game_scrn(SDL_Surface *scr) //Рисуем задник и все все все. Чтобы не писать много раз.
{
    DrawBkg(BKG_GAME,scr);
    DrawPolyCards(scr);
    DrawPlayerCards(scr);
    DrawEnemyCards(scr);
    DrawSlash(scr);
    Skolko_Kakogo();
    Draw_Skolko_Kakogo(scr);
}

void RandomBlocked(SDL_Surface *scr) //Заполняем поле блокираторами от 0 до 6 штук
{
    uint8_t dx,dy;
    uint8_t vi;
    uint8_t dii;
    uint8_t trnd;
    trnd=rand()%6;
    for (uint8_t i=0;i<trnd;i++)
    {
        while (true)
        {
            dx=rand()%4+1;
            dy=rand()%4+1;
            if (pole[dx][dy][0]==NULL) break;
        }

        dii=(rand() & 1)+98;

        for (vi=0;vi<8;vi++)
        {
            Global_Draw_Game_scrn(scr);
            if (dii==98) DrawImage(Blockedcrd_1_hlp[vi],LXtoSX(dx)-10.5+1.3125*vi,LYtoSY(dy)-12.75+1.59375*vi,scr);
            if (dii==99) DrawImage(Blockedcrd_2_hlp[vi],LXtoSX(dx)-10.5+1.3125*vi,LYtoSY(dy)-12.75+1.59375*vi,scr);
            SDL_Flip(scr);
            SDL_Delay(11*fpsmul);
        }
        pole[dx][dy][0]=(card *)dii;
        Global_Draw_Game_scrn(scr);
        //SPU(sBlock)
        SDL_Flip(scr);
        SDL_Delay(8*fpsmul);

    }
}





void DrawPolyCards(SDL_Surface *scr)//Рисуем Поле со всеми картами.
{
    bool dpcd=true;
    for (uint8_t dy=1;dy<5;dy++)
        for (uint8_t dx=1;dx<5;dx++)
        {
            dpcd=true;

            for (uint8_t i=0;i<2;i++)
                if (NotDraw[i][0]==dx && NotDraw[i][1]==dy) dpcd=false;

            if (dpcd)
            {
                if ((uint32_t)(pole[dx][dy][0])==98)
                    DrawImage(Blockedcrd_1,LXtoSX(dx),LYtoSY(dy),scr);

                if ((uint32_t)(pole[dx][dy][0])==99)
                    DrawImage(Blockedcrd_2,LXtoSX(dx),LYtoSY(dy),scr);


                if ((uint32_t)pole[dx][dy][0]==1 || (uint32_t)pole[dx][dy][0]==2)
                    if (pole[dx][dy][1])
                        DrawCard(pole[dx][dy][1]->Number,(uint32_t)(pole[dx][dy][0])-1,\
                                 LXtoSX(dx),LYtoSY(dy),pole[dx][dy][1]->Attack ,\
                                 pole[dx][dy][1]->Atype ,pole[dx][dy][1]->PDefence,\
                                 pole[dx][dy][1]->MDefence ,pole[dx][dy][1]->Arr,scr);
            }

        }
}

void Draw_Skolko_Kakogo(SDL_Surface *scr) //;Рисуем сколько чьих карт
{
    if (InGameRed<10)
        DrawAnimImage(Slash_Red_Numbers,27,152,InGameRed,scr);
    else
    {
        DrawAnimImage(Slash_Red_Numbers,20,152,1,scr);
        DrawAnimImage(Slash_Red_Numbers,37,152,0,scr);
    }

    if (InGameBlue<10)
        DrawAnimImage(Slash_Blue_Numbers,41,189,InGameBlue,scr);
    else
    {
        DrawAnimImage(Slash_Blue_Numbers,34,189,1,scr);
        DrawAnimImage(Slash_Blue_Numbers,51,189,0,scr);
    }
}

void DrawSlash(SDL_Surface *scr) //Рисуем слеш
{
    DrawImage(Slash_img,17,172,scr);
}

void Skolko_Kakogo()//Подсчитываем сколько чьих карт.
{
    InGameBlue=0;
    InGameRed=0;
    for (uint8_t dy=1;dy<5;dy++)
        for (uint8_t dx=1;dx<5;dx++)
        {
            if ((uint32_t )pole[dx][dy][0]==1) InGameBlue++;
            if ((uint32_t )pole[dx][dy][0]==2) InGameRed++;
        }
}

void Init_Game(SDL_Surface *scr) //;Инициализируем переменные игры, которые обязательны.
{
//EnemyVibor(WhoNow)

    FlushCards();
    ClearPole();
    Turn=0;
    InGameRed=0;
    InGameBlue=0;
    Game_Local_May_Exit=false;
    Pl_Half_End=false;
    Pl_Turn_End=false;
    PPdx=1;
    PPdy=1;
    delKilList();
    clearStrelList();

    //enemyScore=EnemyCardsAllScore%()
    //MyScore=PlayerCardsAllScore%()

    /*If  Extended_Music=1 Then
    		If enemyScore<=(MyScore-20) Then
    		Spu_Music(mEasyBattle)
    		EndIf

    		If enemyScore>=(MyScore+20) Then
    		Spu_Music(mHardBattle)
    		EndIf

    		If enemyScore>(MyScore-20) And enemyScore<(MyScore+20) Then
    		Spu_Music(mNormalBattle)
    		EndIf

    Else
    Spu_Music(mCard)
    End If;Врубаем Музыку если расширенный режим*/
    ToFight(scr);
    RandomBlocked(scr);
    RandomFirstTurn(scr);

    DrawGame_LocalScreen(scr);
    SDL_Delay(500);
}


void ToFight(SDL_Surface *scr)
{
//Local timer%
//timer=CreateTimer(50)

    DrawBkg(BKG_GAME,scr);
    DrawPlayerCards(scr);
    DrawSlash(scr);
    Skolko_Kakogo();
    Draw_Skolko_Kakogo(scr);
    SDL_Flip(scr);
    SDL_Delay(100);

    for (uint8_t i=0;i<43;i++)
    {
        DrawBkg(BKG_GAME,scr);
        DrawPlayerCards(scr);
        DrawSlash(scr);
        Draw_Skolko_Kakogo(scr);

        if (i<13)
            DrawImage(enm_Card,16,26+cos(i*0.12083)*214,scr);
        else
            DrawImage(enm_Card,16,26,scr);


        if (i>6 && i<20)
            DrawImage(enm_Card,16,26+14+cos((i-6)*0.12083)*214,scr);
        else if (i>19)
            DrawImage(enm_Card,16,26+14,scr);


        if (i>13 && i<27)
            DrawImage(enm_Card,16,26+28+cos((i-13)*0.12083)*214,scr);
        else if (i>26)
            DrawImage(enm_Card,16,26+28,scr);

        if (i>20 && i<34)
            DrawImage(enm_Card,16,26+42+cos((i-20)*0.12083)*214,scr);
        else if (i>33)
            DrawImage(enm_Card,16,26+42,scr);


        if (i>27 && i<41)
            DrawImage(enm_Card,16,26+56+cos((i-27)*0.12083)*214,scr);
        else if (i>40)
            DrawImage(enm_Card,16,26+56,scr);


        /*if (i=13) Or (i=20) Or (i=27) Or (i=34) Or (i=41) Then
        	SPU(sChif)*/


        SDL_Flip(scr);
#ifdef DINGOO
#else
        SDL_Delay(1000/50);
#endif
    }
    SDL_Delay(300);
}

void RandomFirstTurn(SDL_Surface *scr) //; Первый ход чей?
{
    WhoGo=rand()&1;
    uint32_t MonTime=millisec();
    uint32_t msecs=millisec();
    while (!(millisec()>msecs+800))
    {
        Global_Draw_Game_scrn(scr);
        DrawCoin(scr);
        SDL_Flip(scr);
        if (millisec()>MonTime+83)
        {
            //SPU(sMonetka)
            MonTime=millisec();
        }
    }
    Global_Draw_Game_scrn(scr);
    DrawCoinF(WhoGo,scr);
    SDL_Flip(scr);
    SDL_Delay(500);

    switch (WhoGo)
    {
    case 0:
        DrawCoinMove(0,scr);
        break;
    case 1:
        DrawCoinMove(1,scr);
    }
}


void DrawCoinMove(uint8_t Who,SDL_Surface *scr) //;Рисуем перемещение монетки.
{
    uint32_t Nmtime=millisec();
    switch (Who)
    {
    case 0:
        while (millisec()<Nmtime+250)
        {
            float param;
            param=((Nmtime+250)-millisec())/2.5f;
            Global_Draw_Game_scrn(scr);
            DrawAImage(Coin[0],(274-1.37f*param),0.925f*param,1.27*param,scr);
            SDL_Flip(scr);
        }
        break;
    case 1:
        while (millisec()<Nmtime+250)
        {
            float param;
            param=((Nmtime+250)-millisec())/2.5f;
            Global_Draw_Game_scrn(scr);
            DrawAImage(Coin[4],1.37f*param,0.925f*param,1.27*param,scr);
            SDL_Flip(scr);
        }
    }
}

void PlayerTurn(SDL_Surface *scr)
{

    for (uint32_t i=0;i<5;i++)
        if (MyCards[i][0]==0)
        {
            Sel_Slot=i;
            break;
        }


    card * Pltemp;

    bool NameUbr=false;
    uint32_t NameMil=0;

viborkarti:
    Pl_Half_End=false;
    Pl_Turn_End=false;

    while (!Pl_Half_End)
    {
        Global_Draw_Game_scrn(scr);

        if (input_GetState(Ki_DOWN))
        {
            //SPU(sKlik2)
            Sel_Slot++;
            Sel_Slot%=5;

            for (uint32_t i=0;i<4;i++)
            {
                if ((uint32_t)MyCards[Sel_Slot][0]==1)
                    Sel_Slot++;
                else
                    break;
                Sel_Slot%=5;
            }
        }

        if (input_GetState(Ki_UP))
        {
            //SPU(sKlik2)
            if (Sel_Slot>0)
                Sel_Slot--;
            else
                Sel_Slot=4;
            Sel_Slot%=5;

            for (uint32_t i=0;i<4;i++)
            {
                if ((uint32_t)MyCards[Sel_Slot][0]==1)
                {
                    if (Sel_Slot>0)
                        Sel_Slot--;
                    else
                        Sel_Slot=4;
                }
                else
                    break;
                Sel_Slot%=5;
            }
        }

        if (input_GetState(Ki_X))
        {
            Pl_Half_End=true;
            //SPU(sChif)
        }

        DrawStrelka(252,13+(Sel_Slot)*48,scr);

        //	DrawImage(Buttons_img,16,8,5)
        //	If Lang=0 Then DrawImage(Imia,28,11)
        //	If Lang=1 Then DrawImage(Imia_eng,28,11)
        //	;TextFF(30,8,"-Имя")

        Pltemp=MyCards[Sel_Slot][1];

        if (input_GetState(Ki_R))
        {
            NameUbr=true;
            NameMil=millisec();
        }

        if (millisec()>NameMil+200)
            NameUbr=false;

        if (NameUbr)
        {
            //CreateWindowText(320-(GetFFWidth(cardName[Pltemp\Number])+10),(Sel_Slot*48 - 1 +15),cardName[Pltemp\Number])
        };

        SDL_Flip(scr);//flip2d()
        SDL_Delay(5);
    } // Выбираем карту

    Pl_Half_End=false;
    Pl_Turn_End=false;
    uint8_t dx,dy;

    dx=PPdx;
    dy=PPdy;



    while (!Pl_Turn_End)
    {
        Global_Draw_Game_scrn(scr);
        DrawPlayercardsGrayed(Sel_Slot,scr);

        //;If KeyDown(10) Then testprint()

        if (input_GetState(Ki_DOWN))
        {
            dy++;
            //SPU(sKlik2)
        };
        if (input_GetState(Ki_UP))
        {
            dy--;
            //SPU(sKlik2)
        };
        if (input_GetState(Ki_LEFT))
        {
            dx--;
            //SPU(sKlik2)
        };
        if (input_GetState(Ki_RIGHT))
        {
            dx++;
            //SPU(sKlik2)
        };

        if (dx<1) dx=1;
        if (dx>4) dx=4;
        if (dy<1) dy=1;
        if (dy>4) dy=4;

        if (input_GetState(Ki_O))
        {
            //SPU(sOtmen) :
            goto viborkarti;
        }

        if (input_GetState(Ki_X) && pole[dx][dy][0]==0)
        {
            //SPU(sChif)
            Pl_Turn_End=true;
            MyCards[Sel_Slot][0]=(card *)1;
            pole[dx][dy][0]=(card *)1;
            pole[dx][dy][1]=MyCards[Sel_Slot][1];
            pole[dx][dy][2]=(card *)1;
        }

        DrawStrelka(LXtoSX(dx)-12,LYtoSY(dy)+13,scr);

        SDL_Flip(scr);//flip2d()
        SDL_Delay(5);
    }//Ставим её на поле

    skolko(dx,dy);
    GoFight(dx,dy,1,scr);
    PPdx=dx;
    PPdy=dy;

    Pl_Turn_End=false;
    Pl_Half_End=false;

}
void EnemyTurn(SDL_Surface *scr)
{
    SDL_Delay(400);
    if (Turn==0)
        Bot_PutItDefendedIfFirst(Bot_FindDefencedCard(),scr);
    else
        Bot_FindAndAttack(scr);
}

void Bot_FindAndAttack(SDL_Surface *scr)
{
    Func1();
    Func2();

    if (Bot_Finking(scr)==0)
        Bot_PutItDefendedIfFirst(Bot_FindDefencedCard(),scr);
}


uint8_t FindMinDef(card * s)
{
    return s->MDefence > s->PDefence ? s->PDefence : s->MDefence;
}

uint8_t FindMinDef2(card * s)
{
    uint8_t loc;
    loc= s->MDefence > s->PDefence ? s->PDefence : s->MDefence;
    return loc > s->Attack ? s->Attack : loc;
}

uint8_t GetTypeElement(uint8_t x,uint8_t y,uint8_t z)
{
    return (uint32_t)pole[GetXFromIndex(x,y,z)][GetYFromIndex(x,y,z)][0];
}


uint8_t GetXFromIndex(uint8_t x,uint8_t y,uint8_t z)
{
    switch (z)
    {
    case 1:
        return x-1;

    case 2:
        return x;

    case 3:
        return x+1;

    case 4:
        return x+1;

    case 5:
        return x+1;

    case 6:
        return x;

    case 7:
        return x-1;

    case 8:
        return x-1;
    }
}

uint8_t GetYFromIndex(uint8_t x,uint8_t y,uint8_t z)
{
    switch (z)
    {
    case 1:
        return y-1;

    case 2:
        return y-1;

    case 3:
        return y-1;

    case 4:
        return y;

    case 5:
        return y+1;

    case 6:
        return y+1;

    case 7:
        return y+1;

    case 8:
        return y;
    }
}


uint8_t InvertIndex(uint8_t z)
{
    return (z+3)%8+1;
}



int8_t dim1[6][6];// ;лЮЯЯХБ ЯЙНКЭЙН БЕЯ С ЙЮПРШ
void Func1()
{
    memset(dim1,0,6*6);

    for (uint8_t i=0;i<6;i++)
    {
        dim1[i][0]=-100;
        dim1[i][5]=-100;
        dim1[0][i]=-100;
        dim1[5][i]=-100;
    }

    uint8_t Skollko;
    for (uint8_t y=1;y<5;y++)
        for (uint8_t x=1;x<5;x++)
        {
            Skollko=0;
            if ((uint32_t)pole[x][y][0]==1)
            {
                Skollko=1;
                for (uint8_t z=1;z<9;z++)
                    if ((pole[x][y][1]->Arr >> (z-1)) & 1)
                        if (GetTypeElement(x,y,z)==1)
                            Skollko++;
            }
            dim1[x][y]=Skollko;
        }
}

int8_t dim2[6][6];//лЮЯЯХБ 0, 1 Х 2
void Func2()
{
    memset(dim2,0,6*6);

    for (uint8_t i=0;i<6;i++)
    {
        dim2[i][0]=-100;
        dim2[i][5]=-100;
        dim2[0][i]=-100;
        dim2[5][i]=-100;
    }


    for (uint8_t y=1;y<5;y++)
        for (uint8_t x=1;x<5;x++)
            if (dim1[x][y]>0)
            {
                dim2[x][y]=2;
                for (uint8_t z=1;z<9;z++)
                    if (GetTypeElement(x,y,z)==0)
                        dim2[GetXFromIndex(x,y,z)][GetYFromIndex(x,y,z)]=1;

            }
}

void Bot_PutItDefendedIfFirst(uint8_t Slot,SDL_Surface *scr)
{

    card *temp=EnemyCards[Slot][1];
    uint8_t Array=temp->Arr;

    uint8_t Arrr[16];
    memset(Arrr,0,16);
    uint8_t Skolko;
    for (uint8_t y=1;y<5;y++)
        for (uint8_t x=1;x<5;x++)
        {
            Skolko=0;
            if (pole[x][y][0]==0)
            {
                Skolko=1;
                for (uint8_t z=1;z<9;z++)
                {
                    if ((Array>>(z-1)) & 1)
                        if (GetTypeElement(x,y,z)==0)
                            Skolko++;

                    if (!((Array>>(z-1)) & 1))  //// 1 xor 1 = 1 !!   1 xor 0 = 1!!!
                        if ((GetTypeElement(x,y,z)==99) ||\
                                (GetTypeElement(x,y,z)==98) ||\
                                (GetTypeElement(x,y,z)==100)||\
                                (GetTypeElement(x,y,z)==1))
                            Skolko++;
                }
            }
            Arrr[(x-1)+(y-1)*4]=Skolko;
        }


    uint8_t Arrb[16];
    for (uint8_t i=0;i<16;i++)
        Arrb[i]=i;

    uint8_t tempi;
    for (uint8_t h=0;h<15;h++)
        for (uint8_t i=0;i<15;i++)
            if (Arrr[Arrb[i]]<Arrr[Arrb[i+1]])
            {
                tempi=Arrb[i];
                Arrb[i]=Arrb[i+1];
                Arrb[i+1]=tempi;
            }


    tempi=Arrr[Arrb[0]];
    for (uint8_t i=1;i<16;i++)
        if (!(tempi==Arrr[Arrb[i]]))
        {
            tempi=(i-1);
            break;
        }


    if (tempi>0)
        tempi=rand()%(tempi+1);
    else
        tempi=0;

    tempi=Arrb[tempi];

//SPU(sChif)

    uint8_t dx=((tempi % 4)+1);
    uint8_t dy=(tempi/4 + 1);

    pole[dx][dy][0]=(card *)2;
    pole[dx][dy][1]=EnemyCards[Slot][1];
    pole[dx][dy][2]=(card *)2;
    EnemyCards[Slot][0]=(card *)1;
    skolko(dx,dy);
    GoFight(dx,dy,2,scr);

}

uint8_t Bot_FindDefencedCard()
{
    uint8_t Def,Sel;
    for (uint8_t i=0;i<5;i++)
        if ((uint32_t)EnemyCards[i][0]==0)
        {
            Def=EnemyCards[i][1]->MDefence+EnemyCards[i][1]->PDefence;
            Sel=i;
            break;
        }

    for (uint8_t i=Sel;i<5;i++)
        if ((uint32_t)EnemyCards[i][0]==0)
            if  (Def<(EnemyCards[i][1]->MDefence+EnemyCards[i][1]->PDefence))
            {
                Def=EnemyCards[i][1]->MDefence+EnemyCards[i][1]->PDefence;
                Sel=i;
            }
    return Sel;
}

bool Bot_Finking(SDL_Surface *scr)
{

    struct BotBrain
    {
        uint8_t Slot;
        uint8_t wes;
        uint8_t x;
        uint8_t y;
    };

    BotBrain *temp;

    uint8_t Many;
    BotBrain * listt[80];
    bool Selects;
    uint8_t wsel;

    memset(listt,0,80);
    Many=0;

    for (uint8_t i=0;i<5;i++)
        for (uint8_t y=1;y<5;y++)
            for (uint8_t x=1;x<5;x++)
            {
                Selects=false;
                wsel=0;

                if ((uint32_t)EnemyCards[i][0]==0)
                    if (dim2[x][y]==1)
                    {
                        wsel=1;

                        for (uint8_t z=1;z<9;z++)
                            if (GetTypeElement(x,y,z)==1)
                                if (((pole[GetXFromIndex(x,y,z)][GetYFromIndex(x,y,z)][1]->Arr) >> (InvertIndex(z)-1)) & 1)
                                {
                                    if ((EnemyCards[i][1]->Arr >> (z-1)) & 1)
                                        switch (EnemyCards[i][1]->Atype)
                                        {
                                        case aT_P:
                                            if (EnemyCards[i][1]->Attack>=pole[GetXFromIndex(x,y,z)][GetYFromIndex(x,y,z)][1]->PDefence)
                                                wsel+=dim1[GetXFromIndex(x,y,z)][GetYFromIndex(x,y,z)];
                                            else
                                                Selects=true;
                                            break;
                                        case aT_M:
                                            if (EnemyCards[i][1]->Attack>=pole[GetXFromIndex(x,y,z)][GetYFromIndex(x,y,z)][1]->MDefence)
                                                wsel+=dim1[GetXFromIndex(x,y,z)][GetYFromIndex(x,y,z)];
                                            else
                                                Selects=true;
                                            break;
                                        case aT_X:
                                            if (EnemyCards[i][1]->Attack>=FindMinDef(pole[GetXFromIndex(x,y,z)][GetYFromIndex(x,y,z)][1]))
                                                wsel+=dim1[GetXFromIndex(x,y,z)][GetYFromIndex(x,y,z)];
                                            else
                                                Selects=true;
                                            break;
                                        case aT_A:
                                            if (EnemyCards[i][1]->Attack>=FindMinDef2(pole[GetXFromIndex(x,y,z)][GetYFromIndex(x,y,z)][1]))
                                                wsel+=dim1[GetXFromIndex(x,y,z)][GetYFromIndex(x,y,z)];
                                            else
                                                Selects=true;
                                        }
                                }
                                else
                                {
                                    if ((EnemyCards[i][1]->Arr >> (z-1)) & 1)
                                        wsel++;
                                }
                    }
                if (Selects==false && wsel>0)
                {
                    listt[Many]=new BotBrain;
                    listt[Many]->Slot=i;
                    listt[Many]->wes=wsel;
                    listt[Many]->x=x;
                    listt[Many]->y=y;
                    Many++;
                }
            }
    if (Many>0)
    {
        for (uint8_t j=0;j<Many-1;j++)
            for (uint8_t i=0;i<Many-1;i++)
            {
                if (listt[i]->wes<listt[i+1]->wes)
                {
                    BotBrain *tmp=listt[i];
                    listt[i]=listt[i+1];
                    listt[i+1]=tmp;
                }
            }


        //temp.BotBrain=Object.BotBrain(listt[0])
        //SPU(sChif)
        pole [listt[0]->x] [listt[0]->y] [0]=(card *)2;
        pole [listt[0]->x] [listt[0]->y] [1]=EnemyCards[listt[0]->Slot][1];
        pole [listt[0]->x] [listt[0]->y] [2]=(card *)2;
        EnemyCards[listt[0]->Slot][0]=(card *)1;
        skolko(listt[0]->x,listt[0]->y);
        GoFight(listt[0]->x,listt[0]->y,2,scr);




        return 1;
    }
    else
        return 0;


}

void Game_Turn(SDL_Surface *scr)//;Распределитель ходов
{
    switch (WhoGo)
    {
    case 0:
        PlayerTurn(scr);
        break;
    case 1:
        EnemyTurn(scr);
    }

    WhoGo++;
    WhoGo&=1;

    Turn++;
}


void DrawGame_LocalScreen(SDL_Surface *scr)
{
    while (!Game_Local_May_Exit)
    {
        Global_Draw_Game_scrn(scr);

        Game_Turn(scr);

        Global_Draw_Game_scrn(scr);

        if (Turn>=10) Game_Local_May_Exit=true;

        SDL_Flip(scr);
    }
    Game_Local_May_Exit=false;
}
/*

If InGameRed>InGameBlue Then
	Pl_winLose=Pl_winLose+1
EndIf

If InGameRed<InGameBlue Then
		If enemyScore<=(MyScore-20) Then
			Pl_v_Gil=Pl_v_Gil+50
		EndIf

		If enemyScore>=(MyScore+20) Then
			Pl_v_Gil=Pl_v_Gil+125
		EndIf

		If enemyScore>(MyScore-20) And enemyScore<(MyScore+20) Then
			Pl_v_Gil=Pl_v_Gil+75
		EndIf
	Pl_winWIn=Pl_winWIn+1
EndIf

If InGameRed=InGameBlue Then
	Pl_winBoth=Pl_winBoth+1
EndIf

If Extended_Music=1 Then
	If InGameRed>InGameBlue Then
		Spu_Music(mLose%)
	Else If InGameRed=InGameBlue Then
		Spu_Music(mNich%)
	Else If InGameRed<InGameBlue Then
		Spu_Music(mFanfare%)
	EndIf
Else
	If InGameRed>InGameBlue Then
		SPU(sLose)
	Else If InGameBlue=10 Then
		SPU(sSuper)
	Else If InGameRed=InGameBlue Then
		SPU(sBoth)
	Else If InGameRed<InGameBlue Then
		SPU(sWin)
	EndIf
End If
Local EndAlphaEnd#
EndAlphaEnd=0.0
Local eae_tik%
eae_tik=MilliSecs()
While EndAlphaEnd<255.0
If MilliSecs()>eae_tik+6 Then
eae_tik=MilliSecs()
EndAlphaEnd=EndAlphaEnd+2.55
EndIf

	Global_Draw_Game_scrn()
	If InGameRed>InGameBlue Then
		Draw_State_Of_End(1,EndAlphaEnd)
	Else If InGameBlue=10 Then
		Draw_State_Of_End(2,EndAlphaEnd)
	Else If InGameRed=InGameBlue Then
		Draw_State_Of_End(3,EndAlphaEnd)
	Else If InGameRed<InGameBlue Then
		Draw_State_Of_End(0,EndAlphaEnd)
	EndIf
flip2d()
Wend

While Not (input_GetState("X") Or input_GetState("O") Or input_GetState("SQ") Or input_GetState("TRI"))
Global_Draw_Game_scrn()
	If InGameRed>InGameBlue Then
		Draw_State_Of_End(1,255)
	Else If InGameBlue=10 Then
		Draw_State_Of_End(2,255)
	Else If InGameRed=InGameBlue Then
		Draw_State_Of_End(3,255)
	Else If InGameRed<InGameBlue Then
		Draw_State_Of_End(0,255)
	EndIf
flip2d()
Wend

FlushKeys()
FlushJoy()
Finalize_Game()

DrawBkg(0)
DrawEndCards()
flip2d()
DrawBkg(0)
DrawEndCards()
flip2d()
If DrawTrueOrNo2(GetLangString(11)) ;Сыграть еще?
NextScreen(3)
Else
NextScreen(1)
EndIf
SPU(sChif)

End Function; Здесь собственно и идёт вся игра.

*/

void ClearObaSpiska()
{
    memset(KtoFight,0,9*2);
    memset(KtoOkup,0,9*2);
    SkFight=0;
    SkOkup=0;
}


int32_t sgn(int32_t x)
{
    if (x!=0)
        return x<0? -1 : 1;
    else
        return 0;
}


void InBOOMCARDS(uint8_t x,uint8_t y,uint8_t x2,uint8_t y2,uint8_t Cadr,uint32_t ldx1,uint32_t ldx2,SDL_Surface *scr)
{

    card * tmp1=pole[x][y][1];
    card * tmp2=pole[x2][y2][1];

    int32_t dx=LXtoSX(x);
    int32_t dx2=LXtoSX(x2);
    int32_t dy=LYtoSY(y);
    int32_t dy2=LYtoSY(y2);
    int8_t  dparam=0;

    switch (Cadr)
    {
    case 0:
        dparam=0;
        break;
    case 1:
        dparam=1;
        break;
    case 2:
        dparam=2;
        break;
    case 3:
        dparam=3;
        break;
    case 4:
        dparam=5;
        break;
    case 5:
        dparam=9;
        break;
    case 6:
        dparam=7;
        break;
    case 7:
        dparam=5;
        break;
    case 8:
        dparam=3;
        break;
    case 9:
        dparam=2;
        break;
    case 10:
        dparam=1;
        break;
    case 11:
        dparam=0;
        break;
    }
    DrawCard(tmp1->Number,((uint32_t)pole[x][y][0]-1),(dx+(sgn(dx2-dx))*dparam),\
             (dy+(sgn(dy2-dy))*dparam),tmp1->Attack,tmp1->Atype,tmp1->PDefence,tmp1->MDefence,tmp1->Arr,scr);
    DrawCard(tmp2->Number,((uint32_t)pole[x2][y2][0]-1),(dx2+(sgn(dx-dx2))*dparam),\
             (dy2+(sgn(dy-dy2))*dparam),tmp2->Attack,tmp2->Atype,tmp2->PDefence,tmp2->MDefence,tmp2->Arr,scr);

    DrawOnCardsNumb(dx+(sgn(dx2-dx))*dparam,dy+(sgn(dy2-dy))*dparam,ldx1,scr);
    DrawOnCardsNumb(dx2+(sgn(dx-dx2))*dparam,dy2+(sgn(dy-dy2))*dparam,ldx2,scr);
}




void DrawSelect(SDL_Surface *scr)
{
    for (uint8_t i=1;i<=SkFight;i++)
    {
        //Select Lang
        //	Case 0
        //	DrawImage(Select_img,LXtoSX(KtoFight(i,0))+5,LYtoSY(KtoFight(i,1))+21)
        //	Case 1
        //	DrawImage(Select_img_eng,LXtoSX(KtoFight(i,0))+5,LYtoSY(KtoFight(i,1))+21)
        //End Select

        DrawImage(Select_img,LXtoSX(KtoFight[i][0])+5,LYtoSY(KtoFight[i][1])+21,scr);

    }
}

uint8_t ViborPlayer(SDL_Surface * scr)
{
    bool Maya=false;
    uint8_t dx,dy;
    dx=KtoFight[1][0];
    dy=KtoFight[1][1];

    while (!Maya)
    {
        Global_Draw_Game_scrn(scr);
        DrawSelect(scr);

        if (input_GetState(Ki_DOWN))
        {
            dy++;
            // SPU(sKlik2)
        }
        if (input_GetState(Ki_UP))
        {
            dy--;
            // SPU(sKlik2)
        }
        if (input_GetState(Ki_LEFT))
        {
            dx--;
            // SPU(sKlik2)
        }
        if (input_GetState(Ki_RIGHT))
        {
            dx++;
            // SPU(sKlik2)
        }

        if (dx<1) dx=4;
        if (dx>4) dx=1;
        if (dy<1) dy=4;
        if (dy>4) dy=1;

        if (input_GetState(Ki_X))
            for (uint8_t i=1;i<=SkFight;i++)
                if (dx==KtoFight[i][0] && dy==KtoFight[i][1])
                {
                    return i;
                    Maya=true;
                    break;
                }


        Draw_Vibor_Grayed(scr);
        DrawStrelka(LXtoSX(dx)-12,LYtoSY(dy)+13,scr);
        SDL_Flip(scr);
    }
}


void Draw_Vibor_Grayed(SDL_Surface *scr)
{
    uint8_t Gr[5][5];
    memset(Gr,0,5*5);

    for (uint8_t y=1;y<5;y++)
        for (uint8_t x=1;x<5;x++)
        {
            if (((uint32_t)pole[x][y][0]==1) || ((uint32_t)pole[x][y][0]==2))
                Gr[x][y]=1;

            for (uint8_t i=1;i<=SkFight;i++)
                if ((x==KtoFight[i][0]) && (y==KtoFight[i][1]))
                    Gr[x][y]=0;


            if (Gr[x][y]) DrawAImage(blk_crd_img,LXtoSX(x),LYtoSY(y),160,scr);

        }



}

uint8_t KKil[10][3];
uint8_t StrelList[8];

void clearStrelList()
{
    memset(StrelList,0,8);
}

void DrawStrelkus(uint8_t x, uint8_t y,SDL_Surface *scr)
{
    uint8_t podSS=0;
    for (uint8_t i=0;i<8;i++)
        if (StrelList[i]) podSS++;

    uint32_t mms;
    bool what=true;
    uint8_t mmd=0;
    mms=millisec();

    if (podSS>0)
        while (mmd<12)
        {
            Global_Draw_Game_scrn(scr);
            if (millisec()>(mms+45))
            {
                what=!what;
                mms=millisec();
                mmd++;
            }


            if (what)
            {
                if (StrelList[0])   DrawAnimImage(Arrows,x,y+1,0,scr);
                if (StrelList[1])   DrawAnimImage(Arrows,x+17,y,1,scr);
                if (StrelList[2])   DrawAnimImage(Arrows,x+34,y+1,2,scr);
                if (StrelList[3])   DrawAnimImage(Arrows,x+35,y+21,3,scr);
                if (StrelList[4])   DrawAnimImage(Arrows,x+34,y+44,4,scr);
                if (StrelList[5])   DrawAnimImage(Arrows,x+17,y+45,5,scr);
                if (StrelList[6])   DrawAnimImage(Arrows,x,y+44,6,scr);
                if (StrelList[7])   DrawAnimImage(Arrows,x-1,y+21,7,scr);
            }
            else
            {
                if (StrelList[0])   DrawAnimImage(whArrows,x,y+1,0,scr);
                if (StrelList[1])   DrawAnimImage(whArrows,x+17,y,1,scr);
                if (StrelList[2])   DrawAnimImage(whArrows,x+34,y+1,2,scr);
                if (StrelList[3])   DrawAnimImage(whArrows,x+35,y+21,3,scr);
                if (StrelList[4])   DrawAnimImage(whArrows,x+34,y+44,4,scr);
                if (StrelList[5])   DrawAnimImage(whArrows,x+17,y+45,5,scr);
                if (StrelList[6])   DrawAnimImage(whArrows,x,y+44,6,scr);
                if (StrelList[7])   DrawAnimImage(whArrows,x-1,y+21,7,scr);
            }
            SDL_Flip(scr);
        }

    memset(StrelList,0,8);
}


void addKKilList(uint8_t x,uint8_t y,uint8_t ind)
{
    KKil[0][0]++;
    KKil[KKil[0][0]] [0]=x;
    KKil[KKil[0][0]] [1]=y;
    KKil[KKil[0][0]] [2]=ind;
}

void delKilList()
{
    memset(KKil,0,10*3);
}

void DrawCARDasd(uint8_t x,uint8_t y,uint8_t i,uint8_t frame,SDL_Surface *scr)
{
    switch (i)
    {
    case 1:
        DrawImageARect(wht_crd_img,LXtoSX(x)+40.0-1.5*frame,LYtoSY(y)+49.0-1.821428572*frame,\
                       4,(53.0/28.0)*frame,255.0-frame*8,scr);

        DrawImageARect(wht_crd_img,LXtoSX(x)+40.0-1.5*frame,LYtoSY(y)+49.0-1.821428572*frame,\
                       (46.0/28.0)*frame,4,255.0-frame*8,scr);
        break;
    case 2:
        DrawImageARect(wht_crd_img,LXtoSX(x),LYtoSY(y)+49.0-1.82143*frame,\
                       42,4,255.0-frame*8,scr);
        break;
    case 3:
        DrawImageARect(wht_crd_img,LXtoSX(x)-4.0+1.5714*frame,LYtoSY(y)+49.0-1.821428572*frame,\
                       4,(53.0/28.0)*frame,255.0-frame*8,scr);
        DrawImageARect(wht_crd_img,LXtoSX(x),LYtoSY(y)+49.0-1.821428572*frame,\
                       (46.0/28.0)*frame,4,255.0-frame*8,scr);
        break;
    case 4:
        DrawImageARect(wht_crd_img,LXtoSX(x)-4.0+1.5714*frame,LYtoSY(y),\
                       4,51,255.0-frame*8,scr);
        break;
    case 5:
        DrawImageARect(wht_crd_img,LXtoSX(x)-4.0+1.5714*frame,LYtoSY(y),\
                       4,(53.0/28.0)*frame,255.0-frame*8,scr);

        DrawImageARect(wht_crd_img,LXtoSX(x),LYtoSY(y)-2.0+1.821428572*frame,\
                       (44.0/28.0)*frame,4,255.0-frame*8,scr);
        break;
    case 6:
        DrawImageARect(wht_crd_img,LXtoSX(x),LYtoSY(y)-2.0+1.82143*frame,\
                       42,4,255.0-frame*8,scr);
        break;
    case 7:
        DrawImageARect(wht_crd_img,LXtoSX(x)+40.0-1.5*frame,LYtoSY(y),\
                       4,(53.0/28.0)*frame,255.0-frame*8,scr);

        DrawImageARect(wht_crd_img,LXtoSX(x)+40.0-1.5*frame,LYtoSY(y)-2.0+1.821428572*frame,\
                       (46.0/28.0)*frame,4,255.0-frame*8,scr);
        break;
    case 8:
        DrawImageARect(wht_crd_img,LXtoSX(x)+40.0-1.5*frame,LYtoSY(y),\
                       4,51,255.0-frame*8,scr);
    }

}

void AllKilList(uint8_t HB,bool dRawC,SDL_Surface * scr)
{
    if (KKil[0][0]>0)
    {
        if (dRawC)
        {
            if (KKil[0][0]>0)
                ;//SPU(sCombo)
        }
        else
        {
            if (KKil[0][0]==1)
                ;//SPU(sDzin)
            else
                ;//SPU(sCombo)

        }
        //Local timer%
        //timer=CreateTimer(50)
        for (uint8_t i=0;i<=9;i++)
        {
            Global_Draw_Game_scrn(scr);
            for (uint8_t tmpcrd=1;tmpcrd<=KKil[0][0];tmpcrd++)
                if (dRawC || KKil[tmpcrd][2])
                    DrawCARDasd(KKil[tmpcrd][0],KKil[tmpcrd][1],KKil[tmpcrd][2],i,scr);
                else
                    DrawAImage(wht_crd_img,LXtoSX(KKil[tmpcrd][0]),LYtoSY(KKil[tmpcrd][1]),i*28,scr);

            if (dRawC) Draw_COMBOL(scr);
            SDL_Flip(scr);
#ifndef DINGOO
            SDL_Delay(5*fpsmul);
#endif
        }

        for (uint8_t i=1;i<=KKil[0][0];i++)
            pole[KKil[i][0]] [KKil[i][1]] [0]=(card *)HB;


        for (uint8_t i=10;i<=28;i++)
        {
            Global_Draw_Game_scrn(scr);
            for (uint8_t tmpcrd=1;tmpcrd<=KKil[0][0];tmpcrd++)
                if (dRawC || KKil[tmpcrd][2])
                    DrawCARDasd(KKil[tmpcrd][0],KKil[tmpcrd][1],KKil[tmpcrd][2],i,scr);
                else
                    DrawAImage(wht_crd_img,LXtoSX(KKil[tmpcrd][0]),LYtoSY(KKil[tmpcrd][1]),255-((i-10)*14),scr);

            if (dRawC) Draw_COMBOL(scr);
            SDL_Flip(scr);
#ifndef DINGOO
            SDL_Delay(5*fpsmul);
#endif
        }
        //FreeTimer(timer)
    }
    delKilList();
}


uint8_t CPX,CPY,CPN;
void Combo_Podshet(uint8_t x,uint8_t y)
{
    uint8_t howmanY=0;

    for (uint8_t z=0;z<8;z++)
        switch ((uint32_t)pole[x][y][0])
        {
        case 1:
            if ((pole[x][y][1]->Arr >> z) & 1)
                if ((uint32_t)pole[GetXFromIndex(x,y,z+1)] [GetYFromIndex(x,y,z+1)] [0] == 2)
                    howmanY++;
            break;
        case 2:
            if ((pole[x][y][1]->Arr >> z) & 1)
                if ((uint32_t)pole[GetXFromIndex(x,y,z+1)] [GetYFromIndex(x,y,z+1)] [0] == 1)
                    howmanY++;
        }

    CPX=x;
    CPY=y;
    CPN=howmanY;
}

void Draw_COMBOL(SDL_Surface * scr)
{
    if  (CPN>0)
    {
        DrawImage(Combo,LXtoSX(CPX)+9,LYtoSY(CPY)+18,scr);
        DrawAnimImage(Combo_Numb,LXtoSX(CPX)-7,LYtoSY(CPY)+18,CPN+1,scr);
    }
}

void Kilnut(uint8_t x,uint8_t y,SDL_Surface * scr)
{
    Combo_Podshet(x,y);
    Draw_COMBOL(scr);
    clearStrelList();

    switch ((uint32_t)pole[x][y][0])
    {
    case 1:
        for (uint8_t i=0;i<8;i++)
            if ((pole[x][y][1]->Arr >> i ) & 1)
                if ((uint32_t)pole[GetXFromIndex(x,y,i+1)][GetYFromIndex(x,y,i+1)][0]==2)
                {
                    addKKilList(GetXFromIndex(x,y,i+1),GetYFromIndex(x,y,i+1),i+1);
                    StrelList[i]=1;

                }
        DrawStrelkus(LXtoSX(x),LYtoSY(y),scr);
        AllKilList(1,1,scr);
        break;

    case 2:
        for (uint8_t i=0;i<8;i++)
            if ((pole[x][y][1]->Arr >> i )& 1)
                if ((uint32_t)pole[GetXFromIndex(x,y,i+1)][GetYFromIndex(x,y,i+1)][0]==1)
                {
                    addKKilList(GetXFromIndex(x,y,i+1),GetYFromIndex(x,y,i+1),i+1);
                    StrelList[i]=1;
                }

        DrawStrelkus(LXtoSX(x),LYtoSY(y),scr);
        AllKilList(2,1,scr);

    }
    Global_Draw_Game_scrn(scr);
    SDL_Flip(scr);//flip2d()
    SDL_Delay(500);//*/
}






bool MayNext=true;
void GoFight(uint8_t x,uint8_t y,uint8_t Who,SDL_Surface * scr) //;Пошел на сражение.
{
    MayNext=true;

    uint8_t fp=SkFight;

    if (SkFight!=0)
        switch (Who)
        {
        case 1:
            for (uint8_t i=1;i<=fp;i++)
            {
                skolko(x,y);
                if (SkFight==0) break;
                if (SkFight>1) //Если есть варианты сражения более 1
                {
                    uint8_t tmp=ViborPlayer(scr);
                    if (Fight(x,y, KtoFight[tmp][0] , KtoFight[tmp][1] , scr) ==1)
                    {
                        Kilnut ( KtoFight[tmp][0] , KtoFight[tmp][1] ,scr );
                        DeleteSpisk(tmp);
                        skolko(x,y);
                    }
                    else
                    {
                        Kilnut(x,y,scr);
                        MayNext=false;
                        ClearObaSpiska();
                        break;
                    }
                }
                else
                {
                    if (SkFight==1)
                    {
                        if (Fight(x,y, KtoFight[1][0] , KtoFight[1][1] , scr)==1)
                        {
                            Kilnut( KtoFight[1][0] , KtoFight[1][1] ,scr );
                            skolko(x,y);
                        }
                        else
                        {
                            Kilnut(x,y,scr);
                            MayNext=false;
                            break;
                        }
                    }
                }
            }

            break;
        case 2:
            for (uint8_t i=1;i<=SkFight;i++)
            {
                if ((uint32_t)pole [KtoFight[i][0]] [KtoFight[i][1]] [0]!=Who)
                {
                    if (Fight(x,y, KtoFight[i][0] , KtoFight[i][1] , scr)==1)
                        Kilnut(KtoFight[i][0],KtoFight[i][1],scr);
                    else
                    {
                        Kilnut(x,y,scr);
                        MayNext=false;
                        break;
                    }
                }
            }
        }



    if (MayNext)
    {
        if (SkOkup!=0)
        {
            for (uint8_t t=1;t<=SkOkup;t++)
            {
                if ((uint32_t) pole [KtoOkup[t][0]] [KtoOkup[t][1]] [0]!=Who)
                {
                    addKKilList(KtoOkup[t][0],KtoOkup[t][1],0);
                }
            }
            AllKilList(Who,0,scr);
        }
    }


}


void DeleteSpisk(uint8_t i)
{
    if ((i+1)<=SkFight)
    {
        for (uint8_t ii=i;ii<=(SkFight-1);ii++)
        {
            KtoFight[ii][0]=KtoFight[ii+1][0];
            KtoFight[ii][1]=KtoFight[ii+1][1];
        }
        KtoFight[SkFight][0]=0;
        KtoFight[SkFight][1]=0;
        SkFight--;

    }
    else
    {
        SkFight--;
        KtoFight[i][0]=0;
        KtoFight[i][1]=0;
    }
}

uint32_t Boom_Tik=0;
uint8_t Boom_Cadr=0;
uint8_t DD_Cadr=0;
uint32_t DD_Tik=0;

void DrawBoom(uint32_t x,uint32_t y,SDL_Surface *scr)
{
    DrawAAnimImage(Boom_img,x-20,y-24,Boom_Cadr,175,scr);

    if (millisec()>Boom_Tik+62)
    {
        Boom_Tik=millisec();
        Boom_Cadr++;
    }

}//;Рисуем Взрыв



void ToWhite(uint32_t x,uint32_t y,SDL_Surface *scr)
{
    uint8_t dss=rand() & 1;
    for ( uint8_t i=1; i<=15;i++)
    {
        if ((i % 5)==1) dss=1-dss;
        Global_Draw_Game_scrn(scr);
        if (dss==0)
            DrawAImage(wht_crd_img,x,y,150,scr);
        else
            DrawAImage(wht_crd_img,x,y,80,scr);

        SDL_Flip(scr);//Flip2D()
#ifdef DINGOO
        //SDL_Delay(3*fpsmul);
#else
        SDL_Delay(1000/60);
#endif
    }
} //Карту в белый

void ToWhite2(uint32_t x,uint32_t y,SDL_Surface *scr)
{
    for (uint8_t i=0;i<=255;i+=30)
    {
        Global_Draw_Game_scrn(scr);
        Draw_COMBOL(scr);
        DrawAImage(wht_crd_img,x,y,i,scr);
        SDL_Flip(scr);
    }
}// ; Карту в белый

void FromWhite(uint32_t x,uint32_t y,SDL_Surface *scr)
{
    uint8_t dss=rand() & 1;
    for ( uint8_t i=1; i<=15;i++)
    {
        if ((i % 5)==1) dss=1-dss;
        Global_Draw_Game_scrn(scr);
        if (dss==0)
            DrawAImage(wht_crd_img,x,y,150,scr);
        else
            DrawAImage(wht_crd_img,x,y,80,scr);

        SDL_Flip(scr);//Flip2D()
#ifdef DINGOO
        //SDL_Delay(3*fpsmul);
#else
        SDL_Delay(1000/60);
#endif
    }
}// ;Карту из белого

void FromWhite2(uint32_t x,uint32_t y,SDL_Surface *scr)
{
    for (uint8_t i=255;i>0;i-=30)
    {
        Global_Draw_Game_scrn(scr);
        Draw_COMBOL(scr);
        DrawAImage(wht_crd_img,x,y,i,scr);
        SDL_Flip(scr);
    }
}//;Карту из белого


uint8_t Fight(uint32_t x,uint32_t  y,uint8_t x2,uint8_t y2,SDL_Surface * scr) //;Само сражение
{

    bool win,lose;
    win=false;
    lose=false;


    card *temp = pole[x][y][1];
    card *temp2= pole[x2][y2][1];

    uint8_t Part_1_X1,Part_1_X2;
//;#Region Первая часть боя
    uint8_t TempMax,TempMin;

    if (temp->Atype==aT_A)
    {
        TempMax=temp->Attack;
        if (TempMax<temp->PDefence) TempMax=temp->PDefence;
        if (TempMax<temp->MDefence) TempMax=temp->MDefence;
        Part_1_X1=TempMax*16 + rand()%16;
    }
    else
        Part_1_X1= temp->Attack*16 + rand()%16;


    switch (temp->Atype)
    {
    case aT_P:
        Part_1_X2=temp2->PDefence*16+rand()%16;  // Rand(LetterToNumber(pdef2$)*16,((LetterToNumber(pdef2$)+1)*16)-1)
        break;
    case aT_M:
        Part_1_X2=temp2->MDefence*16+rand()%16; //Part_1_X2=Rand(LetterToNumber(mdef2$)*16,((LetterToNumber(mdef2$)+1)*16)-1)
        break;
    case aT_X:
        TempMin=temp2->MDefence;
        if (TempMin>temp2->PDefence) TempMin=temp2->PDefence;
        Part_1_X2=TempMin*16 + rand()%16;
        break;
    case aT_A:
        TempMin=temp2->Attack;
        if (TempMin>temp2->PDefence) TempMin=temp2->PDefence;
        if (TempMin>temp2->MDefence) TempMin=temp2->MDefence;
        Part_1_X2=TempMin*16 + rand()%16;
    }

//;#End Region

    Global_Draw_Game_scrn(scr);

    DrawOnCardsNumb(LXtoSX(x),LYtoSY(y),Part_1_X1,scr);
    DrawOnCardsNumb(LXtoSX(x2),LYtoSY(y2),Part_1_X2,scr);
    SDL_Flip(scr);
    SDL_Delay(500);

//;#Region Рисуем Boom
    Boom_Cadr=0;
//SPU(sBoom)
    DD_Cadr=0;
    DD_Tik=millisec();
    Boom_Tik=millisec();
    NotDraw[0][0]=x;
    NotDraw[0][1]=y;
    NotDraw[1][0]=x2;
    NotDraw[1][1]=y2;

    while (Boom_Cadr<8)
    {
        Global_Draw_Game_scrn(scr);

        if (Boom_Cadr>=1)
            if (millisec()>=DD_Tik+12)
            {
                DD_Tik=millisec();
                DD_Cadr++;
            }

        if (DD_Cadr>11) DD_Cadr=11;
        InBOOMCARDS(x,y,x2,y2,DD_Cadr,Part_1_X1,Part_1_X2,scr);
        DrawBoom(((LXtoSX(x)+21)+(LXtoSX(x2)+21))/2,((LYtoSY(y)+25)+(LYtoSY(y2)+25))/2,scr);
        SDL_Flip(scr);
    }

    memset(NotDraw,0,4);
//END OF PART1

    uint8_t Part_2_X1,Part_2_X2;

//;#Region Вторая часть боя
    Part_2_X1=rand() % (Part_1_X1+1);
    Part_2_X2=rand() % (Part_1_X2+1);
    if (Part_2_X2==Part_2_X1) Part_2_X2++;

    float SD1,SD2;
    SD1=(Part_1_X1-Part_2_X1)/500.0f;
    SD2=(Part_1_X2-Part_2_X2)/500.0f;

    uint32_t timer_local=millisec()+500;
    while (millisec()<timer_local)
    {
        uint32_t local_time=500-(timer_local-millisec());
        Global_Draw_Game_scrn(scr);
        DrawOnCardsNumb(LXtoSX(x),LYtoSY(y),(Part_1_X1-(SD1*local_time)),scr);
        DrawOnCardsNumb(LXtoSX(x2),LYtoSY(y2),(Part_1_X2-(SD2*local_time)),scr);
        SDL_Flip(scr);
    } //;Проматываем
//END PART2

    Global_Draw_Game_scrn(scr);
    DrawOnCardsNumb(LXtoSX(x),LYtoSY(y),Part_2_X1,scr);
    DrawOnCardsNumb(LXtoSX(x2),LYtoSY(y2),Part_2_X2,scr);
    SDL_Flip(scr);
    SDL_Delay(400);

    if (Part_2_X1>Part_2_X2)
    {
        ToWhite(LXtoSX(x2),LYtoSY(y2),scr);
        pole[x2][y2][0]=pole[x][y][0];
//SPU(sDzin)
        FromWhite(LXtoSX(x2),LYtoSY(y2),scr);
        return 1;
    }
    else
    {
        ToWhite(LXtoSX(x),LYtoSY(y),scr);
        pole[x][y][0]=pole[x2][y2][0];
//SPU(sDzin)
        FromWhite(LXtoSX(x),LYtoSY(y),scr);
        return 0;
    }
}

void DrawOnCardsNumb(uint8_t x,uint8_t y,uint8_t Numb,SDL_Surface *scr) //;Рисуем числа на картах(атака или защита)
{
    char pss[5];
    memset(pss,0,5);
    sprintf(pss,"%d",Numb);

    uint8_t L=strlen(pss);
    switch (L)
    {
    case 1:
        DrawAnimImage(Card_ANumb,x+16,y+18,(uint8_t)pss[0]-0x30,scr);
        break;
    case 2:
        DrawAnimImage(Card_ANumb,x+11,y+18,(uint8_t)pss[0]-0x30,scr);
        DrawAnimImage(Card_ANumb,x+22,y+18,(uint8_t)pss[1]-0x30,scr);
        break;
    case 3:
        DrawAnimImage(Card_ANumb,x+6,y+18,(uint8_t)pss[0]-0x30,scr);
        DrawAnimImage(Card_ANumb,x+17,y+18,(uint8_t)pss[1]-0x30,scr);
        DrawAnimImage(Card_ANumb,x+28,y+18,(uint8_t)pss[2]-0x30,scr);
        break;
    }
}



void skolko(uint8_t x,uint8_t y)
{
    ClearObaSpiska();

    for (uint8_t i=1;i<9;i++)
    {
        uint8_t dx=GetXFromIndex(x,y,i);
        uint8_t dy=GetYFromIndex(x,y,i);
        uint8_t t_tp=(uint32_t)pole[dx][dy][0];
        if (((uint32_t)pole[x][y][1]->Arr >> (i-1)) & 1)
            if ((t_tp!=(uint32_t)pole[x][y][0]) && ((t_tp==1) || (t_tp==2)))
            {
                if (((uint32_t)pole[dx][dy][1]->Arr >> (InvertIndex(i)-1)) & 1)
                {
                    SkFight++;
                    KtoFight[SkFight][0]=dx;
                    KtoFight[SkFight][1]=dy;
                }
                else
                {
                    SkOkup++;
                    KtoOkup[SkOkup][0]=dx;
                    KtoOkup[SkOkup][1]=dy;
                }
            }
    }
}










