#include <SDL/SDL.h>
#include <SDL/SDL_image.h>
#include <SDL/SDL_rotozoom.h>
#include <SDL/SDL_mixer.h>
#include <stdlib.h>
#include <strings.h>
#include <inttypes.h>
#include <time.h>
#include <math.h>





int Load_Game_Resources(SDL_Surface *scr);

const uint32_t screen_w=320;
const uint32_t screen_h=240;



enum aType
{
    aT_P=0,
    aT_M=1,
    aT_X=2,
    aT_A=3
};

struct card
{
    uint8_t Number;
    uint8_t Attack;
    uint8_t PDefence;
    uint8_t MDefence;
    uint32_t Expirience;
    uint8_t Arr;
    uint8_t Atype;
};


#include "system.h"
#include "Graph_FX.h"
#include "FontSystem.h"
#include "Game.h"



///////Global Vars///////
#ifdef RES_H_INCLUDED
SDL_Surface * Card_imgs[100];

SDL_Surface * blRobe;
SDL_Surface * rdRobe;
SDL_Surface * blk_crd_img;
SDL_Surface * wht_crd_img;
anim_surf * Arrows;
anim_surf * whArrows;
anim_surf * cardLetters;
SDL_Surface * enm_Card;
SDL_Surface * Blockedcrd_1;
SDL_Surface * Blockedcrd_1_hlp[8];
SDL_Surface * Blockedcrd_2;
SDL_Surface * Blockedcrd_2_hlp[8];

SDL_Surface *Slash_img;
anim_surf *Slash_Red_Numbers;
anim_surf *Slash_Blue_Numbers;

SDL_Surface *Coin[8];


SDL_Surface * GuiBkg;
anim_surf * GuiCorner;
SDL_Surface * GuiGor;
SDL_Surface *GuiGor2;
SDL_Surface *GuiVert;
SDL_Surface *GuiVert2;

SDL_Surface *Select_img;


///////BKG////////
SDL_Surface *BackGround;
SDL_Surface *BackGround2;
SDL_Surface *SquareBkg;
SDL_Surface *FFIXBkg;
SDL_Surface *FFIXBkgTM;
SDL_Surface *Blk_Bkg;
SDL_Surface *Wht_Bkg;
SDL_Surface *Select_Bkg;
SDL_Surface *Save_Bkg;
SDL_Surface *Load_Bkg;
SDL_Surface *Delete_Bkg;
SDL_Surface *Shop_Bkg;
SDL_Surface *Cards_BKG;
SDL_Surface *Intro_BKG;

SDL_Surface *Combo;
anim_surf *Combo_Numb;

/////--BKG--//////


anim_surf * Font;
anim_surf * CyrFont;


anim_surf * aStrelka;
anim_surf * iStrelka;
anim_surf * Card_ANumb;

anim_surf * Boom_img;



#ifdef DINGOO
float fpsmul=0.1;
#else
float fpsmul=1.0;
#endif

uint32_t Kii=0;


#else
extern SDL_Surface * Card_imgs[100];

extern SDL_Surface * blRobe;
extern SDL_Surface * rdRobe;
extern anim_surf * Arrows;
extern anim_surf * whArrows;
extern anim_surf * cardLetters;
extern SDL_Surface * enm_Card;
extern SDL_Surface * Blockedcrd_1;
extern SDL_Surface * Blockedcrd_1_hlp[8];
extern SDL_Surface * Blockedcrd_2;
extern SDL_Surface * Blockedcrd_2_hlp[8];

extern SDL_Surface *Slash_img;
extern anim_surf *Slash_Red_Numbers;
extern anim_surf *Slash_Blue_Numbers;

extern SDL_Surface *Coin[8];

extern SDL_Surface * wht_crd_img;





extern SDL_Surface * GuiBkg;
extern anim_surf * GuiCorner;
extern SDL_Surface * GuiGor;
extern SDL_Surface *GuiGor2;
extern SDL_Surface *GuiVert;
extern SDL_Surface *GuiVert2;

extern SDL_Surface *Select_img;


///////BKG////////
extern SDL_Surface *BackGround;
extern SDL_Surface *BackGround2;
extern SDL_Surface *SquareBkg;
extern SDL_Surface *FFIXBkg;
extern SDL_Surface *FFIXBkgTM;
extern SDL_Surface *Blk_Bkg;
extern SDL_Surface *Wht_Bkg;
extern SDL_Surface *Select_Bkg;
extern SDL_Surface *Save_Bkg;
extern SDL_Surface *Load_Bkg;
extern SDL_Surface *Delete_Bkg;
extern SDL_Surface *Shop_Bkg;
extern SDL_Surface *Cards_BKG;
extern SDL_Surface *Intro_BKG;

extern SDL_Surface * blk_crd_img;


extern SDL_Surface *Combo;
extern anim_surf   *Combo_Numb;

/////--BKG--//////

extern anim_surf * Font;
extern anim_surf * CyrFont;

extern anim_surf * aStrelka;
extern anim_surf * iStrelka;

extern anim_surf * Card_ANumb;

extern anim_surf * Boom_img;


extern float fpsmul;
extern uint32_t Kii;
#endif // RES_H_INCLUDED

